#!/usr/bin/perl
#   
# Simple script to return list handles and associated bounded urls. 
# It makes use of the REStfulHS service running on localhost port 8082
#
# It wouldn't be to much more work to get it to do something more
#
# @version 1.0 3/30/2012
# @author Nathan Stevens
use strict;
use warnings;
use LWP::Simple;
use XML::LibXML;

# change to your actual prefix
my $prefix = "2333.1";

# the url to get a list of all the handles for a prefix
my $auditURL = "http://localhost:8082/audit/handle/";

# the url for getting handle information about handle
my $infoURL = "http://localhost:8082/id/handle/";

# get the list of handles for the prefix and print them out
my $content = get($auditURL.$prefix);
my @handles = split('\n', $content);

# function to extract bound url from the returned xml
sub getBoundURL() {
	my $parser = XML::LibXML->new();
	my $doc = $parser->load_xml(string => $_[0]);
        
	# get the title node
    my $bnode = ($doc->getElementsByTagName('hs:binding'))[0];
    if($bnode) {    
    		return $bnode->to_literal();
    } else {
    		return "no bounded url";
    }
}

# list the handle now
my $count = 1;
foreach my $handle (@handles) {
	my $statusURL = $infoURL.$handle;

	my $info = get($statusURL);
	my $boundURL = &getBoundURL($info);
	
	print "Handle $count is: $handle || Bound URL: $boundURL \n\n";
	
	#increment the count
	$count++;
}
